from tkinter import *
from tkinter import filedialog
from imagecanvas import *
import math
rootTitle="Morphological operations 準備中"
kernel=[[1,1,1,1,1],
        [1,1,1,1,1],
        [1,1,1,1,1],
        [1,1,1,1,1],
        [1,1,1,1,1]]
kerID=[[0 for i in range(5)] for j in range(5)]
def MinCell(cb,i,j):
    global W,H,kernel
    C=cb.GetPixel(i,j);DT=RED(C)+GREEN(C)+BLUE(C); M=DT
    for k1 in range(-2,2):
        ii=k1+i
        for k2 in range(-2,2):
            jj=k2+j
            if ii>=0 and ii<W and jj>=0 and jj<H and kernel[k1+2][k2+2]==1:
                C=cb.GetPixel(i+k1,j+k2);
                DT=RED(C)+GREEN(C)+BLUE(C)
                if DT<M: M=DT
    return M
def MaxCell(cb,i,j):
    global W,H,kernel
    C=cb.GetPixel(i,j);DT=RED(C)+GREEN(C)+BLUE(C); M=DT
    for k1 in range(-2,2):
        ii=k1+i
        for k2 in range(-2,2):
            jj=k2+j
            if ii>=0 and ii<W and jj>=0 and jj<H and kernel[k1+2][k2+2]==1:
                C=cb.GetPixel(i+k1,j+k2);
                DT=RED(C)+GREEN(C)+BLUE(C)
                if DT>M: M=DT
    return M
def Erode(cb, cbR):
    global W,H,root; k=0
    for i in range(W):
        if i % 10==0:
            k+=1; root.title("Erosion Drawing (%d ％)" % int(i/W*100)+ ('■'*k))
            if k>50: k=0
            root.update()
            
        for j in range(H):
            MinDT=MinCell(cb,i,j)
            DT=int(MinDT/3); C="#%02X%02X%02X" % (DT,DT,DT)
            cbR.SetPixel(i,j, C)
    root.title("Erosion Draw End")

def Dilate(cb, cbR):
    global W,H,root; k=0
    for i in range(W):
        if i % 10==0:
             k+=1; root.title("Dilate Drawing (%d ％)" % int(i/W*100)+ ('■'*k))
             if k>50: k=0
             root.update()
        for j in range(H):
            MaxDT=MaxCell(cb,i,j)
            DT=int(MaxDT/3); C="#%02X%02X%02X" % (DT,DT,DT)
            cbR.SetPixel(i,j, C)
    root.title("Dilation Draw End")
def MoveImage(cb, cbR):
    global W,H
    for i in range(W):
        for j in range(H):
            cb.SetPixel(i,j,cbR.GetPixel(i,j));
def Grad(cb, cbR):
    global W,H,root; k=0
    for i in range(W):
        if i % 10==0:
            k+=1; root.title("Dilate Drawing (%d ％)" % int(i/W*100)+ ('■'*k))
            if k>50: k=0
            root.update()
        for j in range(H):
            MaxDT=MaxCell(cb,i,j)
            MinDT=MinCell(cb,i,j)
            DT=int((MaxDT-MinDT)/3)
            if DT<0  :DT=-DT
            if DT>255:DT=255
            C="#%02X%02X%02X" % (DT,DT,DT)
            cbR.SetPixel(i,j, C)
    root.title("Gradation Draw End")
def Diff(cb, cbR, cbT):
    global W,H,root; k=0
    for i in range(W):
        if i % 10==0:
            k+=1; root.title("Diffence Drawing (%d ％)" % int(i/W*100)+ ('■'*k))
            if k>50: k=0
            root.update()
    
        for j in range(H):
            C=cb.GetPixel(i,j)
            D1=int((RED(C)+GREEN(C)+BLUE(C))/3)
            C=cbR.GetPixel(i,j)
            D2=int((RED(C)+GREEN(C)+BLUE(C))/3)
            DT=D1-D2
            if DT<0  :DT=-DT
            if DT>255:DT=255
            C="#%02X%02X%02X" % (DT,DT,DT)
            cbT.SetPixel(i,j, C)
    root.title("Diffence Draw End")

def OpenM(cb, cbR, cbT):
    Erode(cb, cbT)
    Dilate(cbT, cbR)
    root.title("Opening Draw End")

def CloseM(cb, cbR, cbT):
    Dilate(cb, cbT)
    Erode(cbT, cbR)
    root.title("Closing Draw End")

def TopHat(cb, cbR, cbT):
    OpenM(cb, cbR, cbT)
    root.update()
    Diff(cb,cbR,cbT)
    root.title("Top Hat Draw End")
def BlackHat(cb, cbR, cbT):
    CloseM(cb, cbR, cbT)
    root.update()
    Diff(cb,cbR,cbT)
    root.title("Black Hat Draw End")
def Clear(cb):
    global W,H,root; k=0
    for i in range(W):
        if i % 10==0:
            k+=1; root.title("Clear (%d ％)" % int(i/W*100)+ ('■'*k))
            if k>50: k=0
            root.update()
        for j in range(H):
            cb.SetPixel(i,j, "#FFFFFF")                        
    root.title("Clear End")
def procEr():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True; Clear(cbitR);Erode(cbit, cbitT); ExeFlag=False;
def procDil():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True;Clear(cbitR); Dilate(cbit, cbitT); ExeFlag=False;
def procOpn():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True; OpenM(cbit, cbitT,cbitR); ExeFlag=False;
def procCls():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True; CloseM(cbit, cbitT,cbitR); ExeFlag=False;
def procGrd():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True; Clear(cbitR);Grad(cbit, cbitT); ExeFlag=False;
def procTop():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True; TopHat(cbit, cbitR, cbitT); ExeFlag=False;
def procBlk():
    global ExeFlag, cbit, cbitR, cbitT
    if ExeFlag: return
    ExeFlag=True; BlackHat(cbit, cbitR, cbitT); ExeFlag=False;
def leftMouseDown(event):
    i=int((event.x-2)/8); j=int((event.y-2)/8)
    if i>4: i=4
    if j>4: j=4
    kernel[i][j]=1-kernel[i][j]; C="#FFFFFF"
    if kernel[i][j]!=0:C="#FF0000"
    canTab.itemconfig(kerID[i][j],fill=C)
#■ メイン処理
root=Tk()
FT=[('BMPファイル','*.bmp'), ('すべてのファイル', '*.*')]
DR='c:\\'
filename=filedialog.askopenfilename(filetypes=FT)
if filename!="":
    bitmap=readBitmap(filename)
    root.title(rootTitle)
    if bitmap!=[]:
        #■ビットマップ表示
        W=bitmap.info.width; H=bitmap.info.height
        WW=W+10; HH=H+10; WSIZE=3*WW+60
        if WSIZE<550: WSIZE=550
        root.geometry("%dx%d" % (WSIZE, HH+50))
        canTab=Canvas(root,width=42,height=42)
        canTab.place(x=500, y=0)
        for i in range(5):
            ii=i*8+2
            for j in range(5):
                jj=j*8+2; C="#FFFFFF"
                if kernel[i][j]!=0:C="#FF0000"
                kerID[i][j]=canTab.create_rectangle(ii,jj,ii+8,jj+8,fill=C)
        root.update()

        canvas=Canvas(root,width=W,height=H)
        canvas.place(x=10, y=40)
        cbit=drawBitmap(canvas, bitmap)
        root.update()
        AM=(5,10,25,10,25,0,45,20,25,40,25,30,5,30)
        arrow=Canvas(root,width=W,height=H)
        arrow.place(x=WW+10, y=HH/2+20)
        arrow.create_polygon(AM, fill="red",outline="black")
        canvasT=Canvas(root,width=W,height=H)
        canvasT.place(x=2*WW+60, y=40)
        cbitT=CBitmap(canvasT, W,H, '#FF0000')

        canvasR=Canvas(root,width=W,height=H)
        canvasR.place(x=WW+60, y=40)
        cbitR=CBitmap(canvasR, W,H, '#FF0000')
        ExeFlag=False
        button1 = Button(root, text='Erosion ', command=procEr)
        button1.place(x=10, y=2)
        button2 = Button(root, text='Dilation', command=procDil)
        button2.place(x=80, y=2)
        button3 = Button(root, text='Opening ', command=procOpn)
        button3.place(x=150, y=2)
        button4 = Button(root, text='Closing ', command=procCls)
        button4.place(x=220, y=2)
        button5 = Button(root, text='Gradient', command=procGrd)
        button5.place(x=290, y=2)
        button6 = Button(root, text='Top Hat ', command=procTop)
        button6.place(x=360, y=2)
        button7 = Button(root, text='BlackHat', command=procBlk)
        button7.place(x=430, y=2)
        root.update()
        canTab.bind("<Button-1>",leftMouseDown)

        root.title("Morphological operations");
        root.mainloop()
